/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_ici.h 7591 2013-06-20 08:02:20Z shigihara $
 */

/*
 *  ֳߥɥ饤
 */

#ifndef TOPPERS_TARGET_ICI_H
#define TOPPERS_TARGET_ICI_H

/*
 *  ֳߤγֹ
 */
#define INTNO_ICI0	(UINT_C(0x10000) | CORE_INT_0_INT)
#define INTNO_ICI1	(UINT_C(0x20000) | CORE_INT_1_INT)
#define INTNO_ICI2	(UINT_C(0x30000) | CORE_INT_2_INT)
#define INTNO_ICI3	(UINT_C(0x40000) | CORE_INT_3_INT)

/*
 *  ֳߤγͥ
 */
#ifndef INTPRI_ICI0
#define INTPRI_ICI0	3
#endif /* INTPRI_ICI0 */

#ifndef INTPRI_ICI1
#define INTPRI_ICI1	3
#endif /* INTPRI_ICI1 */

#ifndef INTPRI_ICI2
#define INTPRI_ICI2	3
#endif /* INTPRI_ICI2 */

#ifndef INTPRI_ICI3
#define INTPRI_ICI3	3
#endif /* INTPRI_ICI3 */

/*
 *  ֳֹͥټѥޥ
 */
#define GET_ICI_INTNO(coreid)	target_ici_intno_table[coreid]
#define GET_ICI_INTPRI(coreid)	target_ici_intpri_table[coreid]

#ifndef TOPPERS_MACRO_ONLY
/*
 *  ֳֹ
 */
extern const InterruptNumberType	target_ici_intno_table[];

/*
 *  ֳͥ
 */
extern const PriorityType			target_ici_intpri_table[];
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ץå¸⥸塼NIOS2ѡ
 */
#include "nios2_gcc/prc_ici.h"

#endif /* TOPPERS_TARGET_ICI_H */
